Attribute VB_Name = "DSO_File_IO"

Public Function fnIniRead()
' open and read the INI file
' return values
'  1 = success
'  0 = failure

   Dim I As Integer
   Dim J As Integer
   Dim K As Integer
   Dim LineType As Integer
   Dim Section As Integer
   Dim rMult As Single
   Dim cChar As String * 1
   
' Initialize parameters
   PortAddr = 0
'[Board Types]
'[Channels]
   For I = 1 To MAX_BOARDS
      iBoardType(I) = 0
      bADTrig(I) = NO_TRIG
      For J = 0 To 7
         szChannelName(I, J) = " "
         bLA_Use(I, J) = 0
      Next J

      AD_RangeIndex(I) = 0
      AD_Width(I) = 1
      AD_Color(I) = vbBlack
      AD_Yscale(I) = AD_SCALE_1
      AD_Yoffset(I) = 0
   Next I
   iLAchannels = 0
   iADchannels = 0
   AD_RangeMax = 0

'[TimeBase]
   For I = 0 To TIME_BASE_VALS
      rSamplePeriod(I) = 0#
      szSamplePeriodName(I) = ""
   Next I
   szSamplePeriodName(0) = "RdClk"
   
'[AD_CONFIG]
   For J = 0 To AD_RANGE_MAX     ' A/D parameters
      AD_Range(J, 0) = 0
      AD_Range(J, 1) = 0
      szAD_Range(J) = " "
   Next J

'[Trigger]
   For I = 0 To 7
      bTrig(I) = NO_TRIG
   Next I
   iPreTrig = 1
   iPostTrig = TRIG_MAX - iPreTrig

'[DISPLAY]
   fZoom = 2#
   fSlide = 0.5
   LA_Size = 100
   AD_Size = 100
   For I = 1 To NBR_CURSORS
      iCursorFlag(I) = 0
   Next I
   CursorsColor = COLOR_BLACK
   CursorsWidth = 1
   TGridLinesOn = 0
   TGridLinesColor = COLOR_VIOLET
   TGridLinesWidth = 1
   iTPD = 0             ' force AUTO for Time per Division

' PROCESS THE FILE
   On Error GoTo Error_fnIniRead
   Close                         ' just in case
   Open szIniFileName For Input Access Read As #INI_FILE
   On Error GoTo 0
   Section = 0                   ' init to no section yet
   Do
      LineType = fnIniLine       ' read a line
      Select Case LineType
      Case 0
         Exit Do
      Case 1
         If InStr(szString, "[GENERAL]") = 1 Then Section = GENERAL
         If InStr(szString, "[BOARD_TYPES]") = 1 Then Section = BOARD_TYPES
         If InStr(szString, "[CHANNELS]") = 1 Then Section = CHANNELS
         If InStr(szString, "[TIMEBASE]") = 1 Then Section = TIMEBASE
         If InStr(szString, "[TRIGGER]") = 1 Then Section = TRIGGER
         If InStr(szString, "[DISPLAY]") = 1 Then Section = DISPLAY
         If InStr(szString, "[A/D_CONFIG]") = 1 Then Section = AD_CONFIG
         If InStr(szString, "[END]") = 1 Then Exit Do
      Case 2
         Select Case Section
         
         Case GENERAL
            If InStr(1, szString, "ADDRESS") = 1 Then PortAddr = szParameter
            If InStr(1, szString, "REG_NAME") = 1 Then
               szRegName = szParameter
               frmDSO.Caption = "DSO & Logic Analyzer: Version " & VERSION & ", " & Trim$(szRegName) & "  " & Trim$(szIniFileName)
            End If
         'GENERAL
         
         Case BOARD_TYPES
            If InStr(1, szString, "BOARD_") = 1 Then
               I = Val(Mid$(szString, 7, 2))   ' get board number
               If I < 1 Or I > MAX_BOARDS Then
                  I = MsgBox(szLine, vbOKOnly, "Invalid Board number")
               Else
                  If InStr(1, szParameter, "AD") Then
                     iBoardType(I) = AD_BOARD
                     iADchannels = iADchannels + 1
                  End If
                  If InStr(1, szParameter, "LA") Then iBoardType(I) = LA_BOARD
               End If
            End If
         'BOARD_TYPES
         
         Case CHANNELS
            If InStr(1, szString, "NAME_") = 1 Then
               I = Val(Mid$(szString, 6, 1)) ' get the board number
               J = 0                      ' assume A/D board
               If iBoardType(I) = LA_BOARD Then J = Val(Mid$(szString, 8, 1)) ' get the ch nbr
               szChannelName(I, J) = szParameter
            End If
            If InStr(1, szString, "USE_") = 1 Then
               I = Val(Mid$(szString, 5, 1)) ' get the board number
               If iBoardType(I) = LA_BOARD Then
                  For J = 0 To 7
                     bLA_Use(I, J) = 0    ' default to disabled
                  Next J
                  For J = 1 To 8          ' for each of 8 possible channels
                     cChar = Mid$(szParameter, 9 - J, 1) ' get channel nbr
                     If cChar >= "0" And cChar <= "7" Then
                        iLAchannels = iLAchannels + 1
                        bLA_Use(I, Val(cChar)) = iLAchannels
                     End If
                  Next J
               End If
            End If
            If InStr(1, szString, "TRIG_") = 1 Then
               If iBoardType(I) <> AD_BOARD Then
                  I = MsgBox(szLine, vbOKOnly, "Invalid Trigger for Board")
               End If
               I = Val(Mid$(szString, 6, 1)) ' get the board number
               bADTrig(I) = Val(szParameter) ' get trigger value
            End If
         'CHANNELS
         
         Case TIMEBASE
            If InStr(1, szString, "VALUE") = 1 Then iTimeBaseIndex = Val(szParameter)
            If InStr(1, szString, "SELECT_") = 1 Then
               I = Val(Mid$(szString, 8, 2))   ' get index number
               If I <> 0 And I <= TIME_BASE_VALS Then
                  szSamplePeriodName(I) = szParameter ' store the string
                  If InStr(1, szParameter, "ns") Then rMult = 0.000000001
                  If InStr(1, szParameter, "us") Then rMult = 0.000001
                  If InStr(1, szParameter, "ms") Then rMult = 0.001
                  rSamplePeriod(I) = Val(szParameter) * rMult
               End If
            End If
         'TIMEBASE
         
         Case TRIGGER
            If InStr(1, szString, "PRE_TRIG") = 1 Then
               iPreTrig = Val(szParameter)
            End If
            If InStr(1, szString, "POST_TRIG") = 1 Then
               iPostTrig = Val(szParameter)
            End If
            If InStr(1, szString, "TRIG_") = 1 Then
               J = Val(Mid$(szString, 6, 1))  ' get trigger channel number
               If Mid$(szParameter, 1, 1) = "X" Then
                  bTrig(J) = NO_TRIG          ' show no trigger state
               Else
                  bTrig(J) = Val(szParameter) ' get trigger state
               End If
            End If
            iMax_Samples = ((iPreTrig + iPostTrig) * TRIG_WINDOW) - TRIG_WINDOW / 2
         'TRIGGER
         
         Case DISPLAY
            If InStr(1, szString, "ZOOM") = 1 Then fZoom = szParameter
            If fZoom > 5 Then fZoom = 5
            If fZoom < 1 Then fZoom = 1
            If InStr(1, szString, "SLIDE") = 1 Then fSlide = szParameter
            If fSlide < 0.1 Then fSlide = 0.1
            If fSlide > 1# Then fSlide = 1#
            If InStr(1, szString, "START_SAMPLE") = 1 Then lStartSample = szParameter
            If InStr(1, szString, "END_SAMPLE") = 1 Then lEndSample = szParameter
            If InStr(1, szString, "LA_SIZE") = 1 Then LA_Size = szParameter
            If InStr(1, szString, "AD_SIZE") = 1 Then AD_Size = szParameter
            If InStr(1, szString, "CURSOR_") = 1 Then
               I = Val(Mid$(szString, 8, 1))   ' get cursor number
               If I >= 0 And I <= NBR_CURSORS Then
                  lCursorSample(I) = szParameter
                  iCursorFlag(I) = 1
               End If
            End If
            If InStr(1, szString, "CURSORS_COLOR") = 1 Then CursorsColor = szParameter
            If InStr(1, szString, "CURSORS_WIDTH") = 1 Then CursorsWidth = szParameter
            If InStr(1, szString, "TGRIDLINES_ON") = 1 Then TGridLinesOn = szParameter
            If InStr(1, szString, "TGRIDLINES_COLOR") = 1 Then TGridLinesColor = szParameter
            If InStr(1, szString, "TGRIDLINES_WIDTH") = 1 Then TGridLinesWidth = szParameter
         'DISPLAY

         Case AD_CONFIG
            If InStr(1, szString, "RANGE_") = 1 Then
               I = Val(Mid$(szString, 7, 1))   ' get index number
               If I >= 0 And I <= AD_RANGE_MAX Then
                  szAD_Range(I) = szParameter ' store the string
                  AD_Range(I, 0) = Val(szParameter) ' store lower value
                  J = InStr(1, szParameter, ",")
                  AD_Range(I, 1) = Val(Mid$(szParameter, J + 1)) ' store upper value
                  If I > AD_RangeMax Then AD_RangeMax = I
               End If
            End If
            If InStr(1, szString, "CH_RANGE_") = 1 Then
               I = Val(Mid$(szString, 10, 1))   ' get board  number
               If I >= 1 And I <= MAX_BOARDS Then
                  AD_RangeIndex(I) = szParameter
               End If
            End If
            If InStr(1, szString, "CH_COLOR_") = 1 Then
               I = Val(Mid$(szString, 10, 1))   ' get board number
               If iBoardType(I) = AD_BOARD Then
                  AD_Color(I) = szParameter
               End If
            End If
            If InStr(1, szString, "CH_THICKNESS_") = 1 Then
               I = Val(Mid$(szString, 14, 1))   ' get board number
               If iBoardType(I) = AD_BOARD Then
                  AD_Width(I) = szParameter
                  If AD_Width(I) > 10 Then AD_Width(I) = 10
               End If
            End If
            If InStr(1, szString, "GRID_LINES") = 1 Then GridLines = szParameter
         'AD_CONFIG
         
         End Select ' section
      End Select ' LineType
   Loop
   Close #INI_FILE
   If (iPreTrig + iPostTrig > TRIG_MAX) Or (iPreTrig > iPostTrig) Then
      iPreTrig = 7
      iPostTrig = TRIG_MAX - iPreTrig
      I = MsgBox(szLine, vbOKOnly, "Invalid Pre/Post Trigger Value")
   End If
   fnIniRead = 1                 ' show success
   Exit Function

Error_fnIniRead:
   On Error GoTo 0
   Close #INI_FILE
   I = MsgBox(szIniFileName, vbOKOnly, "Error Opening File")
   fnIniRead = 0                 ' show failure
End Function ' fnIniRead


Public Function fnIniWrite()
' open and write the INI file
' return values
'  1 = success
'  0 = failure

   Dim I As Integer
   Dim Section As Integer
   
   On Error GoTo Error_fnIniWrite
   Close                         ' just in case
   Open szIniFileName For Output Access Write As #INI_FILE
   Print #INI_FILE, ";DSO & Logic Analyzer: Version " & VERSION & ", " & Trim$(szIniFileName)
   Print #INI_FILE, ""

'GENERAL
   Print #INI_FILE, "[GENERAL] ******************************"
   Print #INI_FILE, "ADDRESS = &H" & Trim(Hex$(PortAddr))
   Print #INI_FILE, "REG_NAME = " & Trim(szRegName)
   Print #INI_FILE, ""

'BOARD_TYPES
   Print #INI_FILE, "[BOARD_TYPES] **************************"
   For I = 1 To MAX_BOARDS
      If iBoardType(I) = AD_BOARD Then Print #INI_FILE, "BOARD_" & I & " = AD"
      If iBoardType(I) = LA_BOARD Then Print #INI_FILE, "BOARD_" & I & " = LA"
   Next I
   Print #INI_FILE, ""
   'BOARD_TYPES

'CHANNELS
   Print #INI_FILE, "[CHANNELS] *****************************"
   For I = 1 To MAX_BOARDS
      If iBoardType(I) = AD_BOARD Then
         Print #INI_FILE, "NAME_" & I & " = " & szChannelName(I, 0)
         If bADTrig(I) <> 255 Then
            Print #INI_FILE, "TRIG_" & I & " = " & bADTrig(I)
         End If
      End If
      If iBoardType(I) = LA_BOARD Then
         For J = 0 To 7
            If Mid$(szChannelName(I, J), 1, 1) <> " " Then
               Print #INI_FILE, "NAME_" & I & "." & J & " = " & szChannelName(I, J)
            End If
         Next J
         sLA_Use = "xxxxxxxx"
         For J = 7 To 0 Step -1
            If bLA_Use(I, J) Then
               Mid$(sLA_Use, 8 - J, 1) = J
            End If
         Next J
         Print #INI_FILE, "USE_" & I & " = " & sLA_Use
      End If
   Next I
   Print #INI_FILE, ""
   'CHANNELS

'AD_CONFIG
   Print #INI_FILE, "[A/D_CONFIG] ****************************"
   For I = 0 To AD_RANGE_MAX
      If Mid$(szAD_Range(I), 1, 1) <> " " Then
         Print #INI_FILE, "RANGE_" & I & " = " & szAD_Range(I)
      End If
   Next I
   For I = 1 To MAX_BOARDS
      If iBoardType(I) = AD_BOARD Then
         Print #INI_FILE, "CH_RANGE_" & I & " = " & AD_RangeIndex(I)
         Print #INI_FILE, "CH_COLOR_" & I & " = " & AD_Color(I)
         Print #INI_FILE, "CH_THICKNESS_" & I & " = " & AD_Width(I)
      End If
   Next I
   Print #INI_FILE, "GRID_LINES = " & GridLines
   Print #INI_FILE, ""
   'AD_CONFIG

'TIMEBASE
   Print #INI_FILE, "[TIMEBASE] *****************************"
   Print #INI_FILE, "SELECT_0 = read"
   For I = 1 To TIME_BASE_VALS
      If rSamplePeriod(I) > 0 Then
         Print #INI_FILE, "SELECT_" & I & " = " & Trim$(szSamplePeriodName(I))
      End If
   Next I
   Print #INI_FILE, "VALUE = " & iTimeBaseIndex
   Print #INI_FILE, ""
   'TIMEBASE

'TRIGGER
   Print #INI_FILE, "[TRIGGER] ******************************"
   Print #INI_FILE, "PRE_TRIG = " & iPreTrig
   Print #INI_FILE, "POST_TRIG = " & iPostTrig
   For J = 0 To 7
      cChar = "X"
      If bTrig(J) <> NO_TRIG Then   ' if trigger
         cChar = "0"                ' default to 0 state
         If bTrig(J) = 1 Then cChar = "1"
      End If
      Print #INI_FILE, "Trig_" & J & " = " & cChar
   Next J
   Print #INI_FILE, ""
   'TRIGGER

'DISPLAY
   Print #INI_FILE, "[DISPLAY] ******************************"
   Print #INI_FILE, "ZOOM = " & fZoom
   Print #INI_FILE, "SLIDE = " & fSlide
   Print #INI_FILE, "START_SAMPLE = " & lStartSample
   Print #INI_FILE, "END_SAMPLE = " & lEndSample
   Print #INI_FILE, "LA_SIZE = " & LA_Size
   Print #INI_FILE, "AD_SIZE = " & AD_Size
   For I = 0 To NBR_CURSORS
      If iCursorFlag(I) = 1 Then Print #INI_FILE, "CURSOR_" & I & " = " & lCursorSample(0)
   Next I

   Print #INI_FILE, "CURSORS_COLOR = " & CursorsColor
   Print #INI_FILE, "CURSORS_WIDTH = " & CursorsWidth
   Print #INI_FILE, "TGRIDLINES_ON = " & TGridLinesOn
   Print #INI_FILE, "TGRIDLINES_COLOR = " & TGridLinesColor
   Print #INI_FILE, "TGRIDLINES_WIDTH = " & TGridLinesWidth
   Print #INI_FILE, ""
   'DISPLAY

   Print #INI_FILE, "[End] **********************************"
   Print #INI_FILE, ""

   On Error GoTo 0
   Close #INI_FILE
   fnIniWrite = 1                 ' show success
   Exit Function

Error_fnIniWrite:
   On Error GoTo 0
   Close #INI_FILE
   I = MsgBox(szIniFileName, vbOKOnly, "Error Writing File")
   fnIniWrite = 0                 ' show failure
End Function ' fnIniWrite

Public Function fnIniLine()
    Dim iRetVal, I As Integer, J As Integer, K As Integer
    Dim cFirst As String * 1

' read a line from an ini file
' exit with
'  the line - made upper case - in szString
'  the parameter value - if there is one - in szParameter
'  return value:
'     0 = End of File
'     1 = section name
'     2 = parameter line

   iRetVal = 0                      ' defaul to EOF
   Do
      Line Input #INI_FILE, szString ' read a line
      szString = Trim(szString)     ' remove leading and trailing spaces
      cFirst = Mid$(szString, 1, 1) ' get first character
      If cFirst <> ";" And cFirst <> " " Then ' if not a comment line
   
   ' replace tabs with spaces
         J = InStr(1, szString, Chr$(9))
         While J
            Mid$(szString, J, 1) = Chr$(32)
            J = InStr(1, szString, Chr$(9))
         Wend
   
   ' remove embedded comment
         K = InStr(1, szString, ";")   ' check for comment
         If K <> 0 Then                ' if comment at end of line
            szString = Trim(Left$(szString, K - 1)) ' remove comment
         End If
   
   ' test for section name
         If InStr(1, szString, "[") = 1 Then
            iRetVal = 1 ' show section
            UCase (szString)           ' make upper case
         End If
   ' get the parameter - if there is one
         K = InStr(1, szString, "=")
         If K <> 0 Then
            szParameter = Mid$(szString, K + 1, 15) ' copy the parameter value
            UCase (Mid$(szString, 1, K)) ' make upper case
            iRetVal = 2                ' show parameter present
            szParameter = Trim$(szParameter)
         End If
        
         Exit Do
      End If ' if not a comment
   Loop While Not EOF(INI_FILE)
   fnIniLine = iRetVal

End Function  'fnIniLine

